#!/usr/bin/perl

# Copyright (C) 2000,2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: ethernet_info.pm,v 1.1.1.1 2001/06/13 11:37:28 rchaillat Exp $

package backend::ethernet_info;


# Arg0 : interface name (eth0, eth1, ...)
# returns :
#   (string) MAC Address
sub get_interface_info {

    if (0 == scalar (@_)) { return; }
    
    my $interface = shift @_;
    print STDERR "Ethernet_info : retrieving information for $interface \n";
    
    my $info = `/sbin/ifconfig $interface 2>/dev/null`;
    $info =~ s/\s+/ /g; # substitute all tabs and line feeds by spaces
    
    # See if we need to proceed
    if ($info !~ /HWaddr/) { exit (1); } # no mac address, hence no useful info
    
    # parse interface info to extract valuable information
    my %eth_info = ();
    ($eth_info{macaddr} = $info."\n" ) =~ s/.*HWaddr (\S+) .*/$1/;

    return $eth_info{macaddr};

# TODO : retrieve other infos ? (MTU, ...)
}


# Don't forget it's perl...
1;
