#!/usr/bin/perl -w

# Copyright (C) 2000,2001 Mandrakesoft
# Author Florin Grad <florin@mandrakesoft.com>
# 
# $Id: dns-hosts.pl,v 1.1.1.1 2001/06/13 11:37:28 rchaillat Exp $
#

use strict;
use lib qw(/usr/lib/naat);
use backend::util;

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if ( @ARGV && $ARGV[1] !~ /^-/ );

my $Usage =<<"End_of_Usage;";

Usage:	dns-hosts.pl [trans_name] domain_name < -l | -a name IP | -d name (|IP) >
	dns-hosts.pl [trans_name] domain_name < --list | --add name IP | --delete name (|IP) >

--list|-l	Displays the list of the already defined hostnames

--add|-a	Adds a user in the hosts name lists
		EXAMPLE: dns-hosts.pl design.net -a sunlight 192.168.1.125

--delete|-d	Deletes the line(s) coresponding to the hostname or IPaddress argument
		EXAMPLE: dns-hosts.pl design.net -d sunlight (or 192.168.1.125)

End_of_Usage;

my $chroot = "/var/named";

# arg0 : list | add | delete

# Check if there are at least 2 arguments given
if ( scalar (@ARGV) le 1 ) {
    print STDERR $Usage;
    exit(3);
}

if ( $ARGV[1] eq "--list" || $ARGV[1] eq "-l") {
	backend::util::print_list_dns_hosts_names ($chroot, $ARGV[0]);
} elsif ( $ARGV[1] eq "--add" || $ARGV[1] eq "-a") {
	backend::util::add_dns_hosts_names ($chroot, $ARGV[0], $ARGV[2], $ARGV[3]);
	backend::util::increase_serial ($chroot, $ARGV[0]);
} elsif ( $ARGV[1] eq "--delete" || $ARGV[1] eq "-d") {
	backend::util::delete_dns_hosts_names ($chroot, $ARGV[0], $ARGV[2]);
	backend::util::increase_serial ($chroot, $ARGV[0]);
} else {
print STDERR $Usage;
};

