#!/usr/bin/perl -W

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: ifcfg.pl,v 1.1.1.1 2001/06/13 11:37:28 rchaillat Exp $
#

use File::Basename;

# Stop or Start an ethernet interface based on the name 
# with which this script was launched

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;


for ($0) {

    # keep only the relevant info
    my $name = basename $_;
    
    # split action (start or stop) and interface name
    my ($action,$interface) = split /-/, $name;

#    print "$action $interface \n";

    # analyze action and operate
    $action =~ /start/ and do { 
	[ -e "/etc/sysconfig/network-scripts/ifcfg-$interface" ] &&
	system ("/sbin/ifup",   "$interface" ); 
    };
    $action =~ /stop/  and do { 
	[ -e "/etc/sysconfig/network-scripts/ifcfg-$interface" ] &&
	system ("/sbin/ifdown", "$interface" ); 
    };

}
