#!/usr/bin/perl -W

# Copyright (C) 2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: internet-access.pl,v 1.1.1.1 2001/06/13 11:37:29 rchaillat Exp $
#

# Start or Stop the Internet connection


# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if (@ARGV && $ARGV[0] !~ /^-/);

exit if $ARGV[0] !~ /^-/;

(my $operation = $ARGV[0]) =~ s/^-//;

if (! $transaction_name ) {
    $transaction_name = "$$";
    # initialize a backend transaction
    system ("config-wrapper.pl $transaction_name -i");
}

my $internet_type = `config-wrapper.pl $transaction_name -g InternetAccessType`;
if ( $internet_type =~ /adsl/i ) {
    system ("sudo","/sbin/service", "adsl", $operation);
} 
elsif ( $internet_type =~ /isdn/i ) {
    system ("sudo","/sbin/service", "isdn4linux", $operation);
    system ("sudo","/sbin/service", "diald", $operation);
}
elsif ( $internet_type =~ /ppp/i ) {
    system ("sudo","/sbin/service", "diald", $operation);
}
elsif ( $internet_type =~ /lan/i ) {
    # get the external interface
    my $interface = `config-wrapper.pl $transaction_name -g InternetInterface`;

    # start or stop it
    $operation =~ /start/i and do { 
	[ -e "/etc/sysconfig/network-scripts/ifcfg-$interface" ] &&
	system ("sudo","/sbin/ifup",   "$interface" ); 
    };
    $operation =~ /stop/i  and do { 
	[ -e "/etc/sysconfig/network-scripts/ifcfg-$interface" ] &&
	system ("sudo","/sbin/ifdown", "$interface" ); 
    };
}


if ( $transaction_name eq "$$" ) {
    # cleanup the transaction
    system ("config-wrapper.pl $transaction_name -a");
}


