#include <rrd_tool.h>

#define BUFLEN 63000

int format_number (char*buf, double val)
{
  int res;
  if ((val / 1024) < 1) {
    snprintf (buf, BUFLEN, "%d%%20Byte", res = val);
    return 0;
  }
  if ((val / (1024*1024)) < 1) {
    snprintf (buf, BUFLEN, "%d%%20KB", res = val/(1024));
    return 0;
  }
  if ((val / (1024.0*1024*1024.0)) < 1) {
    snprintf (buf, BUFLEN, "%d%%20MB", res = val/(1024*1024.0));
    return 0;
  }
  if ((val / (1024.0*1024*1024*1024.0)) < 1) {
    snprintf (buf, BUFLEN, "%d%%20GB", res = val/(1024.0*1024*1024.0));
    return 0;
  }
  snprintf (buf, BUFLEN, "%d%%20TB", res = val/(1024.0*1024*1024*1024*1024.0));
  return 0;  
}



int
main(int argc, char **argv)    
{   
  char buf1 [BUFLEN];
  char buf2 [BUFLEN];
  char file [BUFLEN];
  int          ii,row;
  rrd_value_t  values[2]; /* in and out */
  long         rra_base, rra_start, rra_next;
  FILE                  *in_file;
  rrd_t             rrd;
  double in, out;
  
  if (argc != 3) {
    printf("Usage : format-interface-volume.pl <transaction_name> <interface>\n");
    exit(1);
  }

  snprintf (file, BUFLEN, "/var/lib/monitoring/net/%s.rrd", argv[2]);
  if(rrd_open(file,&in_file,&rrd, RRD_READONLY)==-1){
    return(-1);
  }

  rra_base=ftell(in_file);    
  rra_next = rra_base;
  

  //printf("<table border=2><tr><td></td><td>IN</td><td>OUT</td></tr>"); 
//  printf("<table border=2><tr><td></td><td>IN</td><td>OUT</td></tr>"); 
  
  /* Day sum */
  in = out = 0;
  rra_start= rra_next;
  rra_next +=  ( rrd.stat_head->ds_cnt
		 * rrd.rra_def[0].row_cnt
		 * sizeof(rrd_value_t));
  fseek(in_file,(rra_start
		 +(rrd.rra_ptr[0].cur_row+1)
		 * rrd.stat_head->ds_cnt
		 * sizeof(rrd_value_t)),SEEK_SET);
  ii=rrd.rra_ptr[0].cur_row;    
  for(row=0;row<rrd.rra_def[0].row_cnt;row++){	    
    ii++;
    if (ii>=rrd.rra_def[0].row_cnt) {
      fseek(in_file,rra_start,SEEK_SET);
      ii=0; /* wrap if max row cnt is reached */
    }
    fread(values,sizeof(rrd_value_t),2,in_file);
    if (!isnan(values[0])){
      in += values[0];
    }
    if (!isnan(values[1])){
      out += values[1];
    };
  }

  format_number (buf1, in * 300);
  format_number (buf2, out * 300);      
  //printf ("<tr><td>Last%%2024%%20hours</td><td>%s</td><td>%s</td></tr>", buf1 , buf2);
  printf ("Last%%2024%%20hours (IN=%s OUT=%s),", buf1 , buf2);

  /* Week sum */
  in = out = 0;
  rra_start= rra_next;
  rra_next +=  ( rrd.stat_head->ds_cnt
		 * rrd.rra_def[1].row_cnt
		 * sizeof(rrd_value_t));
  fseek(in_file,(rra_start
		 +(rrd.rra_ptr[1].cur_row+1)
		 * rrd.stat_head->ds_cnt
		 * sizeof(rrd_value_t)),SEEK_SET);
  ii=rrd.rra_ptr[1].cur_row;    
  for(row=0;row<rrd.rra_def[1].row_cnt;row++){	    
    ii++;
    if (ii>=rrd.rra_def[1].row_cnt) {
      fseek(in_file,rra_start,SEEK_SET);
      ii=0; /* wrap if max row cnt is reached */
    }
    fread(values,sizeof(rrd_value_t),2,in_file);
    if (!isnan(values[0])){
      in += values[0];
    }
    if (!isnan(values[1])){
      out += values[1];
    };
  }

  format_number (buf1, in * 1800);
  format_number (buf2, out * 1800);
  //printf ("<tr><td>Last%%207%%20days</td><td>%s</td><td>%s</td></tr>", buf1, buf2);
  printf ("Last%%207%%20days (IN=%s OUT=%s),", buf1, buf2);


    /* Month sum */
  in = out = 0;
  rra_start= rra_next;
  rra_next +=  ( rrd.stat_head->ds_cnt
		 * rrd.rra_def[2].row_cnt
		 * sizeof(rrd_value_t));
  fseek(in_file,(rra_start
		 +(rrd.rra_ptr[2].cur_row+1)
		 * rrd.stat_head->ds_cnt
		 * sizeof(rrd_value_t)),SEEK_SET);
  ii=rrd.rra_ptr[2].cur_row;    
  for(row=0;row<rrd.rra_def[2].row_cnt;row++){	    
    ii++;
    if (ii>=rrd.rra_def[2].row_cnt) {
      fseek(in_file,rra_start,SEEK_SET);
      ii=0; /* wrap if max row cnt is reached */
    }
    fread(values,sizeof(rrd_value_t),2,in_file);
    if (!isnan(values[0])){
      in += values[0];
    }
    if (!isnan(values[1])){
      out += values[1];
    };
  }


  format_number (buf1, in * 7200);
  format_number (buf2, out * 7200);      
  //printf ("<tr><td>Last%%20month</td><td>%s</td><td>%s</td></tr>", buf1 ,  buf2);
  printf ("Last%%20month (IN=%s OUT=%s),", buf1 ,  buf2);

    /* Year sum */
  in = out = 0;
  rra_start= rra_next;
  rra_next +=  ( rrd.stat_head->ds_cnt
		 * rrd.rra_def[3].row_cnt
		 * sizeof(rrd_value_t));
  fseek(in_file,(rra_start
		 +(rrd.rra_ptr[3].cur_row+1)
		 * rrd.stat_head->ds_cnt
		 * sizeof(rrd_value_t)),SEEK_SET);
  ii=rrd.rra_ptr[3].cur_row;    
  for(row=0;row<rrd.rra_def[3].row_cnt;row++){	    
    ii++;
    if (ii>=rrd.rra_def[3].row_cnt) {
      fseek(in_file,rra_start,SEEK_SET);
      ii=0; /* wrap if max row cnt is reached */
    }
    fread(values,sizeof(rrd_value_t),2,in_file);
    if (!isnan(values[0])){
      in += values[0];
    }
    if (!isnan(values[1])){
      out += values[1];
    };
  }


  format_number (buf1, in * 86400);
  format_number (buf2, out * 86400);      
  //printf ("<tr><td>Last%%20year</td><td>%s</td><td>%s</td></tr>", buf1, buf2);
  printf ("Last%%20year (IN=%s OUT=%s)", buf1, buf2);

//  printf ("</table>");
  rrd_free(&rrd);
  fclose(in_file);
  return(0);
}


