#!/usr/bin/perl -W

# Copyright (C) 2000,2001 Mandrakesoft
# Author Renaud Chaillat <rchaillat@mandrakesoft.com>
#
# $Id: update-ethernet.pl,v 1.1.1.1 2001/06/13 11:37:28 rchaillat Exp $
#

# Bring down inactive interfaces and delete associated ifcfg-ethx files
# Activation should be performed by post step on Ethx<varname> events

# First get the transaction name (FIRST STEP IN ALL SCRIPTS)
my $transaction_name = shift @ARGV if @ARGV;

if (! $transaction_name ) {
    $transaction_name = "$$";
    # initialize a backend transaction
    system ("config-wrapper.pl $transaction_name -i");
}


# Look for Known Ethernet Interfaces 
my $active_interfaces_list = `config-wrapper.pl $transaction_name -g EthernetKnownInterfaces 2>/dev/null`;

#
# Delete ifcfg-ethx when ethx is not listed in EthernetKnownInterfaces
# If there's no active ethx, then they're all deleted
# TODO: Really let the user deactivate all eth ?
#
if (defined ($active_interfaces_list) ) { 
    chomp $active_interfaces_list;
    my @active_interfaces = split /\s*,\s*/, "\L$active_interfaces_list";

    # Get currently defined ethernet interfaces in network-scripts
    my @defined_interfaces = `ls /etc/sysconfig/network-scripts/ifcfg*`;
    @defined_interfaces = grep { /ifcfg-eth\d+$/ } @defined_interfaces;

    # find defined interfaces that are not active anymore and unlink these files
    my %seen;
    my @defined_only;
    @seen{@active_interfaces} = (); # define a hash with active interfaces names as keys

    foreach (@defined_interfaces) {
	my $interface = $_; 
	$interface =~ s!/etc/sysconfig/network-scripts/ifcfg-!!;
	chomp $interface;
	chomp $_;
	push (@defined_only, $_ ) unless exists $seen{$interface};
    }

    if ( scalar (@defined_only) ) {
	print STDERR "Interfaces defined and not active, deleting:\n @defined_only \n";
	foreach (@defined_only) {
	    # bring down interfaces
	    my $interface = $_; 
	    $interface =~ s!/etc/sysconfig/network-scripts/ifcfg-!!;
	    system ("/sbin/ifdown $interface");
	    # remove unnecessary ifcfg-ethx files
	    [ -f $_ ] && unlink $_;
	}
    }
} 


if ( $transaction_name eq "$$" ) {
    # cleanup the transaction
    system ("config-wrapper.pl $transaction_name -a");
}
